{ This is the input data:
 4
 + -7 + 4 * 2 * 5


                                 
                                  
                                 
                   
                    1998 .


      N  ,         
 .         - "+"  "*".
        N-,    
     .
                                 2
                        (-7)+(4)
                                        
                                        
           N = 4       1  +              *  3
                                        
                                        
                         (5)*(2)
                                 4
         1  N   -
 .    :        . 
        (),     
   .      3,   
 :                   *     +      +
                       (2)   (5)   (-7)   (4)
          Z   V1  V2  -
 ,    .  Z, V1  V2     ,  
    Z,   V1  V2.    
     .        .  
  ,     -  -
    ,           
    .    2 .    
 N,             :
          1  1  2  2  ...  N  N
 ,        1, ..    N 
  1,      1  2.      -
  :
          4
          + -7 + 4 * 2 * 5
       1  - -   -  
    ,          -
 . N <= 50.           
   [-32768..32767].

 :   ,      -
           .  -
        - 1    1  .
    Z,     ,  
      Z+1.     ,  -
   .  ,        
     .      ,  
        (     
 ),      .      -
       ,       -
    " ".       -
       ,     -
 ,    .  F(v1,v2)   , 
        ,   v1  -
    v2  M(v1,v2)      . 
       F(1,N),   ,  
     F(1,N) :

        F(v,v) = R[v]
        F(v1,v2) =  Z[i] = '+'
                     max( F(v1,i)+F(i+1,v2) )  i = v1...v2-1
                    Z[i] = '*'
                     max( F(v1,i)*F(i+1,v2),
		          M(v1,i)*M(i+1,v2) )
                      i = v1...v2-1

        M(v,v) = R[v]
        M(v1,v2) =  Z[i] = '+'
                     max( M(v1,i)+M(i+1,v2) )  i = v1...v2-1
                    Z[i] = '*'
                     max( M(v1,i)*M(i+1,v2),
		          M(v1,i)*F(i+1,v2),
			  F(v1,i)*M(i+1,v2),
		          F(v1,i)*F(i+1,v2) )
                      i = v1...v2-1

   R[v]     v,    Z[i]  
    i  i+1.     ,  v1>v2
   F(v1,v2) >= M(v1,v2)     v1  v2.  
  .  ,     ,    -
       (v1...i)  (i+1...v2)  
 Z[i],          
 (v1...v2).       N*(N+1)/2,    -
              -
  O(N*N*N).          ,
  ,             -
      .      
     ,        --
 .        ,    
       ,   .-
   ,          
     ,       -    -
  .           4-   -
           .
            N*N*N*N.
}

CONST MaxN        = 50;
      InFileName  = 'prusten.pas';
      OutFileName = '';
      NotDefined  = MaxInt;

VAR R: array[1..MaxN] of integer; {vertices}
    Z: array[1..MaxN] of char;    {signs between the vertices}
    Optimal: array[1..MaxN] of integer;
    TableF,TableM: array[1..MaxN,1..MaxN] of integer;
    N: byte;


Procedure ReadData; {Read the input data - N, Prusten[1..N], PrustenZ[1..N]}
Var F: Text;
    Z1: char;
Begin
  Assign(F,InFileName); Reset(F); ReadLn(F);
  ReadLn(F,N);
  for N:= 1 to N do
    begin
      Read(F,Z[N]); if Z[N] = ' ' then Read(F,Z[N]);
      Read(F,R[N]);
    end;
  Close(F);
  Z1:=Z[1]; Move(Z[2],Z[1],N-1); Z[N]:=Z1;
End;


Function M(v1,v2:byte): integer; forward;

Function F(v1,v2:byte): integer; { Calculate maximal result for v1...v2 }
Var Max: integer;
    i: byte;
Begin
  if v1 = v2 then
    begin F:=R[v1]; Exit; end;

  if TableF[v1,v2] <> NotDefined then
    begin F:=TableF[v1,v2]; Exit; end; {Already calculated}

  Max:=-MaxInt;
  for i:= v1 to v2-1 do
    if Z[i] = '*' then
      begin
        if F(v1,i)*F(i+1,v2) > Max then
          Max:= F(v1,i)*F(i+1,v2);
        if M(v1,i)*M(i+1,v2) > Max then
          Max:= M(v1,i)*M(i+1,v2);
      end
    else {if Z[i] = '+' then}
      if F(v1,i)+F(i+1,v2) > Max then
        Max:= F(v1,i)+F(i+1,v2);
  TableF[v1,v2]:=Max; F:=Max;
End;

Function M(v1,v2:byte): integer; { Calculate minimal result for v1...v2 }
Var Min: integer;
    i: byte;
Begin
  if v1 = v2 then
    begin M:=R[v1]; Exit; end;

  if TableM[v1,v2] <> NotDefined then
    begin M:=TableM[v1,v2]; Exit; end; {Already calculated}

  Min:=MaxInt;
  for i:= v1 to v2-1 do
    if Z[i] = '*' then
      begin
        if M(v1,i)*M(i+1,v2) < Min then
          Min:= M(v1,i)*M(i+1,v2);
        if M(v1,i)*F(i+1,v2) < Min then
          Min:= M(v1,i)*F(i+1,v2);
        if F(v1,i)*M(i+1,v2) < Min then
          Min:= F(v1,i)*M(i+1,v2);
        if F(v1,i)*F(i+1,v2) < Min then
          Min:= F(v1,i)*F(i+1,v2);
      end
    else {if Z[i] = '+' then}
      if M(v1,i)+M(i+1,v2) < Min then
        Min:= M(v1,i)+M(i+1,v2);
  TableM[v1,v2]:=Min; M:=Min;
End;


Procedure CalculateOptimals; { Calculate Optimal[1..N] }
{ Optimal[i] = the maximal value when we remove the side i }
Var Side,i,j: integer;
    Z1: char;
    R1: integer;
Begin
  for Side:= 1 to N do
    begin
      { Calculate Optimal result if remove the side Side }
      for i:= 1 to N do
        for j:= 1 to N do
          begin TableF[i,j]:=NotDefined; TableM[i,j]:=NotDefined; end;
      Optimal[Side]:=F(1,N);
      { Rotate right R[1..N] and Z[1..N] }
      Z1:=Z[1]; R1:=R[1];
      Move(Z[2],Z[1],(N-1)*SizeOf(Z[1]));
      Move(R[2],R[1],(N-1)*SizeOf(R[1]));
      Z[N]:=Z1; R[N]:=R1;
    end;
End;


Procedure Print; { Find and print the maximal result from Optimal[1..N] }
Var i,Max: integer;
    OutF: Text;
Begin
  Assign(OutF,OutFileName); Rewrite(OutF);
  Max:=-MaxInt;
  for i:= 1 to N do {Find maximal result}
    if Optimal[i] > Max then
      Max:= Optimal[i];
  WriteLn(OutF,Max); {Print maximal result}
  for i:= 1 to N do {Print the sides we can obtain this result from}
    if Optimal[i] = Max then
      Write(OutF,i,' ');
  WriteLn(OutF); WriteLn(OutF);
  Close(OutF);
End;


BEGIN
  ReadData;
  CalculateOptimals;
  Print;
END.
